local BS = AceLibrary("Babble-Spell-2.2")

--Downranking exceptions: Death Coil, Siphon life, Searing Pain, Hellfire
--Untested assumed normal: UA, Conflagrate, Shadowfury
--No downranking: Lifetap, Drain soul, CoA

function DrDamage:WarlockData()

	local WarlockTable = {

		spellInfo = {
			[BS["Corruption"]] = {
						[0] = { School = { "Shadow", "Affliction", }, bonusFactor = 0.93, castTime = 2, eDot = true, eDuration = 18, sTicks = 3, Downrank = -2, CastMod = 0.1 },
						[1] = { 40, 40, spellLevel = 4, maxLevel = 13, eDuration = 12, Downrank = -3, },
						[2] = { 90, 90, spellLevel = 14, maxLevel = 23, eDuration = 15, },
						[3] = { 222, 222, spellLevel = 24, maxLevel = 33, },
						[4] = { 324, 324, spellLevel = 34, maxLevel = 43, },
						[5] = { 486, 486, spellLevel = 44, maxLevel = 53, }, 
						[6] = { 666, 666, spellLevel = 54, maxLevel = 59, },
						[7] = { 822, 822, spellLevel = 60, maxLevel = 64, },
						[8] = { 906, 906, spellLevel = 65, maxLevel = 70, },
			},
			[BS["Shadow Bolt"]] = {
						[0] = { School = { "Shadow", "Destruction" }, castTime = 3, canCrit = true, CastMod = 0.1, BaseIncrease = true, },
						[1] = { 12, 16, 1, 2, spellLevel = 1, maxLevel = 5, castTime = 1.7, Downrank = 2, },
						[2] = { 23, 29, 3, 4, spellLevel = 6, maxLevel = 11, castTime = 2.2, Downrank = 2, },
						[3] = { 48, 56, 4, 5, spellLevel = 12, maxLevel = 19, castTime = 2.8, },
						[4] = { 86, 98, 6, 6, spellLevel = 20, maxLevel = 27, },
						[5] = { 142, 162, 8, 8, spellLevel = 28, maxLevel = 35, },
						[6] = { 204, 230, 9, 10, spellLevel = 36, maxLevel = 43, },
						[7] = { 281, 315, 11, 12, spellLevel = 44, maxLevel = 51, },
						[8] = { 360, 402, 13, 13, spellLevel = 52, maxLevel = 59, }, 
						[9] = { 455, 507, 15, 15, spellLevel = 60, maxLevel = 67, },
						[10] ={ 482, 538, 15, 16, spellLevel = 60, maxLevel = 68, },
						[11] ={ 541, 603, 3, 4, spellLevel = 69, maxLevel = 70, },
			},
			[BS["Life Tap"]] = {
						[0] = { School = { "Shadow", "Affliction", }, bonusFactor = 0.8, NoSchoolTalents= true, NoDPS = true, NoTooltip = true, NoBuffs = true, NoDebuffs = true, Unresistable = true, BaseIncrease = true, NextRank = 10, },
						[1] = { 20, 20, 10, 10, spellLevel = 6, },
						[2] = { 65, 65, 10, 10, spellLevel = 16, },
						[3] = { 130, 130, 10, 10, spellLevel = 26, },
						[4] = { 210, 210, 10, 10, spellLevel = 36, },
						[5] = { 300, 300, 10, 10, spellLevel = 46, },
						[6] = { 420, 420, 10, 10, spellLevel = 56, },
						[7] = { 580, 580, 10, 10, spellLevel = 66, },
			},
			[BS["Dark Pact"]] = {
						[0] = { School = { "Shadow", "Affliction", }, bonusFactor = 0.96, NoSchoolTalents= true, NoDPS = true, NoTooltip = true, NoBuffs = true, NoDebuffs = true, Unresistable = true, },
						[1] = { 305, 305, spellLevel = 40, },
						[2] = { 440, 440, spellLevel = 50, },
						[3] = { 545, 545, spellLevel = 60, },
						[4] = { 700, 700, spellLevel = 70, },
			},			
			[BS["Curse of Agony"]] = {
						[0] = { School = { "Shadow", "Affliction", }, bonusFactor = 1.20, eDot = true, eDuration = 24, },
						[1] = { 84, 84, spellLevel = 8,  },
						[2] = { 180, 180, spellLevel = 18, },
						[3] = { 324, 324, spellLevel = 28, }, 
						[4] = { 504, 504, spellLevel = 38, }, 
						[5] = { 780, 780, spellLevel = 48, }, 
						[6] = { 1044, 1044, spellLevel = 58, },
						[7] = { 1356, 1356, spellLevel = 67, }, 
			},
			[BS["Curse of Doom"]] = {
						[0] = { School = { "Shadow", "Affliction", }, sFactor = 0.5, NoSchoolTalents = true, eDot = true, eDuration = 60, },
						[1] = { 3200, 3200, spellLevel = 60, },
						[2] = { 4200, 4200, spellLevel = 70, },
			},
			[BS["Death Coil"]] = {
						[0] = { School = { "Shadow", "Affliction", }, sFactor = 0.5, Cooldown = 120, Leech = true, NoDoom = true, BaseIncrease = true, Downrank = 1, },
						[1] = { 244, 244, 13, 13, spellLevel = 42, maxLevel = 49, },
						[2] = { 319, 319, 15, 15, spellLevel = 50, maxLevel = 57, }, 
						[3] = { 400, 400, 18, 18, spellLevel = 58, maxLevel = 67, },
						[4] = { 519, 519, 6, 7, spellLevel = 68, maxLevel = 70, },
						--Note: Downrank: +1 -> exception
			},
			[BS["Drain Life"]] = {
						[0] = { School = { "Shadow", "Affliction", }, castTime=5, Leech = true, sHits = 5, sFactor = 0.5, },
						[1] = { 10, 10, spellLevel = 14, maxLevel = 21, },
						[2] = { 17, 17, spellLevel = 22, maxLevel = 29, },
						[3] = { 29, 29, spellLevel = 30, maxLevel = 37, },
						[4] = { 41, 41, spellLevel = 38, maxLevel = 45, },
						[5] = { 55, 55, spellLevel = 46, maxLevel = 53, },
						[6] = { 71, 71, spellLevel = 54, maxLevel = 61, },
						[7] = { 87, 87, spellLevel = 62, maxLevel = 68, },
						[8] = { 108, 108, spellLevel = 69, maxLevel = 70, },
			},
			[BS["Drain Soul"]] = { 
						[0] = { School = { "Shadow", "Affliction", }, castTime=15, sFactor = 0.5, sTicks = 3, },
						[1] = { 55, 55, spellLevel = 10, },
						[2] = { 155, 155, spellLevel = 24, },
						[3] = { 295, 295, spellLevel = 38, },
						[4] = { 455, 455, spellLevel = 52, },
						[5] = { 620, 620, spellLevel = 67, }, 
			},
			[BS["Siphon Life"]] = {
						[0] = { School = { "Shadow", "Affliction", }, sHits = 10, Leech = true, eDot = true, eDuration = 30, sFactor = 0.5, Downrank = 3, },
						[1] = { 15, 15, spellLevel = 30, maxLevel = 37, },
						[2] = { 22, 22, spellLevel = 38, maxLevel = 47, },
						[3] = { 33, 33, spellLevel = 48, maxLevel = 57, },
						[4] = { 45, 45, spellLevel = 58, maxLevel = 62, },
						[5] = { 52, 52, spellLevel = 63, maxLevel = 69, },
						[6] = { 63, 63, spellLevel = 70, maxLevel = 70, },
						--Note: Downranking +3, why?
			},
			[BS["Searing Pain"]] = { 
						[0] = { School = { "Fire", "Destruction" }, canCrit = true, BaseIncrease = true, Downrank = 1, },
						[1] = { 34, 42, 4, 5, spellLevel = 18, maxLevel = 25, },
						[2] = { 59, 71, 6, 6, spellLevel = 26, maxLevel = 33, },
						[3] = { 86, 104, 7, 8, spellLevel = 34, maxLevel = 41, },
						[4] = { 122, 146, 9, 9, spellLevel = 42, maxLevel = 49, },
						[5] = { 158, 188, 10, 10, spellLevel = 50, maxLevel = 57, },
						[6] = { 204, 240, 12, 12, spellLevel = 58, maxLevel = 64, },
						[7] = { 243, 287, 9, 10, spellLevel = 65, maxLevel = 69, },
						[8] = { 270, 320, 0, 0, spellLevel = 70, maxLevel = 70, },
						--Note: Downranking +1 -> exception
			},
			[BS["Soul Fire"]] = {
						[0] = { School = { "Fire", "Destruction" }, bonusFactor = 1.15, castTime=6, canCrit = true, CastMod = 0.4, BaseIncrease = true, Cooldown = 60 },
						[1] = { 623, 783, 17, 18, spellLevel = 48, maxLevel = 55, },
						[2] = { 703, 881, 18, 19, spellLevel = 56, maxLevel = 63, },
						[3] = { 839, 1051, 14, 14, spellLevel = 64, maxLevel = 69, },
						[4] = { 1003, 1257, 0, 0, spellLevel = 70, maxLevel = 70, },
			},
			[BS["Shadowburn"]] = {
						[0] = { School = { "Shadow", "Destruction" }, Cooldown = 15, canCrit = true, BaseIncrease = true, },
						[1] = { 87, 99, 4, 6, spellLevel = 20, maxLevel = 23, },
						[2] = { 115, 131, 8, 9, spellLevel = 24, maxLevel = 31, },
						[3] = { 186, 210, 10, 11, spellLevel = 32, maxLevel = 39, },
						[4] = { 261, 293, 13, 14, spellLevel = 40, maxLevel = 47, },
						[5] = { 350, 392, 15, 16, spellLevel = 48, maxLevel = 55, },
						[6] = { 450, 502, 17, 19, spellLevel = 56, maxLevel = 62, },
						[7] = { 518, 578, 20, 21, spellLevel = 63, maxLevel = 69, },
						[8] = { 597, 665, 0, 0, spellLevel = 70, maxLevel = 70, },
			},
			[BS["Immolate"]] = {
						[0] = { School = { "Fire", "Destruction" }, canCrit = true, castTime=2, CastMod = 0.1, hybridFactor = 0.349, eDuration = 15, sTicks = 3, BaseIncrease = true, Downrank = -2, },
						[1] = { 8, 8, 2, 2, hybridDotDmg = 20, spellLevel = 1, maxLevel = 9, },
						[2] = {	19, 19, 4, 4, hybridDotDmg = 40, spellLevel = 10, maxLevel = 19, }, 	 
						[3] = { 45, 45, 7, 7, hybridDotDmg = 90, spellLevel = 20, maxLevel = 29, },	 
						[4] = { 90, 90, 10, 10, hybridDotDmg = 165, spellLevel = 30, maxLevel = 39, }, 
						[5] = { 134, 134, 13, 13, hybridDotDmg = 255, spellLevel = 40, maxLevel = 49, },
						[6] = { 192, 192, 16, 16, hybridDotDmg = 365, spellLevel = 50, maxLevel = 59, }, 
						[7] = { 258, 258, 19, 19, hybridDotDmg = 485, spellLevel = 60, maxLevel = 69, },
						[8] = { 279, 279, 19, 20, hybridDotDmg = 510, spellLevel = 60, maxLevel = 69, },
						[9] = { 327, 327, 4, 5, hybridDotDmg = 615, spellLevel = 69, maxLevel = 70, },
			},
			[BS["Hellfire"]] = {
						[0] = { School = "Fire", castTime=15, sHits = 15, sFactor = 1/2, BaseIncrease = true, Downrank = 1, },
						[1] = { 83, 83, 4, 4, spellLevel = 30, maxLevel = 41, },
						[2] = { 139, 139, 5, 5, spellLevel = 42, maxLevel = 53, },
						[3] = { 208, 208, 7, 7, spellLevel = 54, maxLevel = 67, },
						[4] = { 306, 306, 1, 2, spellLevel = 68, maxLevel = 70, },
						--Note: Downrank +1 -> exception
			},
			[BS["Rain of Fire"]] = { 
						[0] = { School = "Fire", castTime=8, sFactor = 0.83 * 1/2, sTicks = 2, BaseIncrease = true, Downrank = -4, },
						[1] = { 168, 168, 4, 8, spellLevel = 20, maxLevel = 33, Downrank = -6, },
						[2] = { 384, 384, 8, 8, spellLevel = 34, maxLevel = 45, },
						[3] = { 620, 620, 8, 12, spellLevel = 46, maxLevel = 57, },
						[4] = { 904, 904, 12, 12, spellLevel = 58, maxLevel = 68, },
						[5] = { 1212, 1212, 0, 4, spellLevel = 69, maxLevel = 70, },
			},
			[BS["Unstable Affliction"]] = {
						[0] = { School = { "Shadow", "Affliction", }, eDot = true, eDuration = 18, sTicks = 3, Downrank = -2 },
						[1] = { 660, 660, spellLevel = 50, maxLevel = 59, },
						[2] = { 840, 840, spellLevel = 60, maxLevel = 69, },
						[3] = { 1050, 1050, spellLevel = 70, maxLevel = 70, },
			},
			[BS["Conflagrate"]] = { 
						[0] = { School = { "Fire", "Destruction" }, canCrit = true, BaseIncrease = true, Downrank = 2, },
						[1] = { 240, 306, 9, 10, spellLevel = 40, maxLevel = 47, },
						[2] = { 316, 396, 10, 11, spellLevel = 48, maxLevel = 53, },
						[3] = { 383, 479, 11, 13, spellLevel = 54, maxLevel = 59, },
						[4] = { 447, 557, 0, 0, spellLevel = 60, maxLevel = 64, }, --Check
						[5] = { 512, 638, 0, 0, spellLevel = 65, maxLevel = 69, },
						[6] = { 579, 721, 0, 0, spellLevel = 70, maxLevel = 70, },
			},
			[BS["Seed of Corruption"]] = { 
						[0] = { School = { "Shadow", "Affliction", }, canCrit = true, sFactor = 1/2, eDuration = 18, hybridDotFactor = 2 * 1.25, sTicks = 3, },
						[1] = { 1110, 1290, hybridDotDmg=1044, spellLevel = 70, maxLevel = 70, },
			},
			[BS["Shadowfury"]] = { 
						[0] = { School = { "Shadow", "Destruction" }, canCrit = true, sFactor = 1/2 * 0.95, Cooldown = 20, BaseIncrease = true, Downrank = -2, },
						[1] = { 343, 407, 14, 15, spellLevel = 50, maxLevel = 59, },
						[2] = { 459, 547, 0, 0, spellLevel = 60, maxLevel = 69, }, --Check
						[3] = { 612, 728, 0, 0, spellLevel = 70, maxLevel = 70, },
			},
			[BS["Incinerate"]] = { 
						[0] = { School = { "Fire", "Destruction" }, canCrit = true, castTime = 2.5, BaseIncrease = true,  },
						[1] = { 403, 467, 13, 13, incinerateMin = 100, incinerateMax = 116, spellLevel = 64, maxLevel = 69, },
						[2] = { 444, 514, 0, 0, incinerateMin = 111, incinerateMax = 128, spellLevel = 70, maxLevel = 70, },
			},			
		},	

		talentInfo = {
			--Affliction:
			["Shadow Mastery"] = { Effect = 0.02, Spells = { "Shadow" }, },			
			["Suppression"] = { Effect = 2, Spells = { "Affliction", }, ModType ="Hit", },
			["Improved Corruption"] = { Effect = 1, Spells = { "Corruption" }, ModType = "CastTime" },
			--["Soul Siphon"] = { Effect = 1, Spells = { "Drain Life" }, ModType = "Soul Siphon", },
			["Improved Life Tap"] = { Effect = 0.10, Spells = { "Life Tap" }, },		
			["Improved Curse of Agony"] = { Effect = 0.05, Spells = { "Curse of Agony" }, Add = true, }, --Multiplicative?
			["Empowered Corruption"] = { Effect = 0.12, Spells = { "Corruption" }, ModType = "SpellDamage", },
			["Contagion"] = { Effect = 0.01, Spells = { "Curse of Agony", "Corruption", "Seed of Corruption" }, },
			--Destruction:
			["Emberstorm"] = { Effect = 0.02, Spells = { "Fire" }, },
			["Improved Immolate"] = { Effect = 0.05, Spells = { "Immolate" }, ModType = "BaseNuke" },
			["Shadow and Flame"] = { Effect = 0.04, Spells = { "Shadow Bolt", "Incinerate" }, ModType = "SpellDamage", },
			["Bane"] = { Effect = 1, Spells = { "Shadow Bolt", "Immolate", "Soul Fire" }, ModType = "CastTime" },
			["Devastation"] = { Effect = 1, Spells = { "Destruction" }, ModType = "Crit", },
			["Backlash"] = { Effect = 1, Spells = { "All" }, ModType = "Crit", },
			["Improved Searing Pain"] = { Effect = { 4, 7, 10, }, Spells = { "Searing Pain" }, ModType = "Crit", },
			["Ruin"] = { Effect = 0.5, Spells = { "Destruction" }, ModType = "CritMultiplier", },
			--Demonology:		
			["Demonic Tactics"] = { Effect = 0.01, Spells = { "All" }, },
			["Master Demonologist"] = { Effect = 1, Spells = { "All" }, ModType = "MD" },
		},
	}

	return WarlockTable["spellInfo"], WarlockTable["talentInfo"]
end