local GT = AceLibrary("Gratuity-2.0")
local Deformat = AceLibrary("Deformat-2.0")		
		
local tierSets = {}
local armorSets = {
	DRUID = { "Cenarion Raiment", "Stormrage Raiment", "Genesis Raiment", "Malorne Armor", "Nordrassil Armor" },
	HUNTER = { "Giantstalker Armor", "Dragonstalker Armor", "Striker's Garb", "Cryptstalker Armor", "Demon Stalker Armor", }, --TODO: Tier5
	MAGE = { "Arcanist Regalia", "Netherwind Regalia", "Enigma Vestments", "Frostfire Regalia", "Scryer Armor", "Tirisfal Armor" },
	PALADIN = { "Lawbringer Armor", "Judgement Armor", "Avenger's Battlegear", "Redemption Armor", "Justicar Armor" }, --TODO: tier 5, tier4: armor, battlegear and raiment
	PRIEST = { "Vestments of Prophecy", "Vestments of Transcendence", "Garments of the Oracle", "Vestments of Faith", "Incarnate Armor", }, --Tier 5
	ROGUE = { "Nightslayer Armor", "Bloodfang Armor", "Deathdealer's Embrace", "Bonescythe Armor", "Netherblade Armor", "Deathmantle Armor" },
	SHAMAN = { "The Earthfury", "The Ten Storms", "Stormcaller's Garb", "The Earthshatterer", "Cyclone Armor", "Cataclysm Armor" },
	WARLOCK = { "Felheart Raiment", "Nemesis Raiment", "Doomcaller's Attire", "Plagueheart Raiment", "Voidheart Armor", "Corruptor Armor" },
	WARRIOR = { "Battlegear of Might", "Battlegear of Wrath", "Conqueror's Battlegear", "Dreadnaught's Battlegear", "Warbringer Armor", }, --Tier5
}

function DrDamage:ItemSets()

	for k in ipairs( tierSets ) do
		tierSets[k] = nil
	end

	local _, englishClass = UnitClass("player")

	for i = 1, 12 do
		local link = GetInventoryItemLink( "player", i )
		if link then 
			GT:SetHyperlink( link )
			for j = 2, GT:NumLines() do
				setName, setAmount = Deformat(GT:GetLine(j), ITEM_SET_NAME)
				if setName then
					for tier, set in ipairs( armorSets[englishClass] ) do
						if setName == set then
							tierSets[tier] = setAmount
						end
					end					
				end
			end
		end
	end
	
	for i = 1, 6 do
		if not tierSets[i] then
			tierSets[i] = 0
		end
	end
	
	return tierSets
end